Codeforces 482B 线段树

2024-09-09 07:18
文章标签 codeforces 线段 482b

本文主要是介绍Codeforces 482B 线段树,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

求是否存在这样的n个数;

m次操作,每次操作就是三个数 l ,r,val

         a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。


也就是意味着区间[L , R] 每个数要执行 | val 操作 

最后判断  a[l] & a[l+1] &......&a[r] 是否= val

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.StringTokenizer;public class Main {public static void main(String[] args){new CF482B().solve()  ; }
}class CF482B{InputReader in = new InputReader(System.in) ;PrintWriter out = new PrintWriter(System.out) ;void solve(){int n = in.nextInt() ;int m = in.nextInt() ;build(1 , 1 , n) ;for(int i = 1 ;  i <= m ; i++){l[i] = in.nextInt() ;r[i] = in.nextInt() ;q[i] = in.nextInt() ;update(l[i] , r[i] , q[i] , 1 , 1, n) ;}boolean can = true ;for(int i = 1 ; i <= m ; i++){if(query(l[i] , r[i] , 1 , 1 , n) != q[i]){can = false ;break ; }}if(can){out.println("YES") ; for(int i = 1 ; i <= n ; i++){if(i > 1) out.print(" ") ;out.print(query(i , i , 1 , 1 , n)) ;}out.println() ;}else out.println("NO")  ;out.flush() ;}final int N = 100008 ;int[] sum = new int[N<<2] ;int[] add = new int[N<<2] ;int[] l = new int[N] ;int[] r = new int[N] ;int[] q = new int[N] ;void build(int t , int l , int r){sum[t] = add[t] = 0 ;if(l == r) return ;int mid = (l + r) >> 1 ;build(t<<1 , l , mid) ;build(t<<1|1 , mid+1 , r) ;up(t) ;}void up(int t){sum[t] = sum[t<<1] & sum[t<<1|1] ;}void down(int t){if(add[t] != 0){sum[t<<1] |= add[t] ;sum[t<<1|1] |= add[t] ;add[t<<1] |= add[t] ;add[t<<1|1] |= add[t] ;add[t] = 0 ;}}void update(int L , int R , int v ,  int t , int l , int r){if(L <= l && r <= R){add[t] |= v ;sum[t] |= v ;return ;}down(t) ;int mid = (l + r) >> 1 ;if(L <= mid) update(L, R, v , t<<1 , l , mid)  ;if(R > mid) update(L , R , v , t<<1|1 , mid+1 , r) ;up(t) ;}int query(int L , int R , int t , int l , int r){if(L <= l && r <= R) return sum[t] ;int res = (1<<30) - 1  ; down(t) ;int mid = (l + r) >> 1 ;if(L <= mid) res &= query(L, R, t<<1 , l , mid) ;if(R > mid) res &= query(L, R, t<<1|1 , mid+1 , r) ;up(t) ;return res ;}}class InputReader {  public BufferedReader reader;  public StringTokenizer tokenizer;  public InputReader(InputStream stream) {  reader = new BufferedReader(new InputStreamReader(stream), 32768);  tokenizer = new StringTokenizer("");  }  private void eat(String s) {  tokenizer = new StringTokenizer(s);  }  public String nextLine() {  try {  return reader.readLine();  } catch (Exception e) {  return null;  }  }  public boolean hasNext() {  while (!tokenizer.hasMoreTokens()) {  String s = nextLine();  if (s == null)  return false;  eat(s);  }  return true;  }  public String next() {  hasNext();  return tokenizer.nextToken();  }  public int nextInt() {  return Integer.parseInt(next());  }  public long nextLong() {  return Long.parseLong(next());  }  public double nextDouble() {  return Double.parseDouble(next());  }  public BigInteger nextBigInteger() {  return new BigInteger(next());  }  }  

   


这篇关于Codeforces 482B 线段树的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1150514

相关文章

poj3468(线段树成段更新模板题)

题意:包括两个操作:1、将[a.b]上的数字加上v;2、查询区间[a,b]上的和 下面的介绍是下解题思路: 首先介绍  lazy-tag思想:用一个变量记录每一个线段树节点的变化值,当这部分线段的一致性被破坏我们就将这个变化值传递给子区间,大大增加了线段树的效率。 比如现在需要对[a,b]区间值进行加c操作,那么就从根节点[1,n]开始调用update函数进行操作,如果刚好执行到一个子节点,

hdu1394(线段树点更新的应用)

题意:求一个序列经过一定的操作得到的序列的最小逆序数 这题会用到逆序数的一个性质,在0到n-1这些数字组成的乱序排列,将第一个数字A移到最后一位,得到的逆序数为res-a+(n-a-1) 知道上面的知识点后,可以用暴力来解 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#in

hdu1689(线段树成段更新)

两种操作:1、set区间[a,b]上数字为v;2、查询[ 1 , n ]上的sum 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdl

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

poj 1127 线段相交的判定

题意: 有n根木棍,每根的端点坐标分别是 px, py, qx, qy。 判断每对木棍是否相连,当他们之间有公共点时,就认为他们相连。 并且通过相连的木棍相连的木棍也是相连的。 解析: 线段相交的判定。 首先,模板中的线段相交是不判端点的,所以要加一个端点在直线上的判定; 然后,端点在直线上的判定这个函数是不判定两个端点是同一个端点的情况的,所以要加是否端点相等的判断。 最后

HDU4737线段树

题目大意:给定一系列数,F(i,j)表示对从ai到aj连续求或运算,(i<=j)求F(i,j)<=m的总数。 const int Max_N = 100008 ;int sum[Max_N<<2] , x[Max_N] ;int n , m ;void push_up(int t){sum[t] = sum[t<<1] | sum[t<<1|1] ;}void upd

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

zoj 1721 判断2条线段(完全)相交

给出起点,终点,与一些障碍线段。 求起点到终点的最短路。 枚举2点的距离,然后最短路。 2点可达条件:没有线段与这2点所构成的线段(完全)相交。 const double eps = 1e-8 ;double add(double x , double y){if(fabs(x+y) < eps*(fabs(x) + fabs(y))) return 0 ;return x + y ;

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m